Add module containing function for getting info from Xen
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 hypervisordir = $(pkgpythondir)/hypervisor
44 blockdir = $(pkgpythondir)/block
45 httpdir = $(pkgpythondir)/http
46 masterddir = $(pkgpythondir)/masterd
47 confddir = $(pkgpythondir)/confd
48 rapidir = $(pkgpythondir)/rapi
49 serverdir = $(pkgpythondir)/server
50 watcherdir = $(pkgpythondir)/watcher
51 impexpddir = $(pkgpythondir)/impexpd
52 utilsdir = $(pkgpythondir)/utils
53 toolsdir = $(pkglibdir)/tools
54 iallocatorsdir = $(pkglibdir)/iallocators
55 pytoolsdir = $(pkgpythondir)/tools
56 docdir = $(datadir)/doc/$(PACKAGE)
57 myexeclibdir = $(pkglibdir)
58
59 # Delete output file if an error occurred while building it
60 .DELETE_ON_ERROR:
61
62 HS_DIRS = \
63         src \
64         src/Ganeti \
65         src/Ganeti/Block \
66         src/Ganeti/Block/Drbd \
67         src/Ganeti/Confd \
68         src/Ganeti/Curl \
69         src/Ganeti/DataCollectors \
70         src/Ganeti/HTools \
71         src/Ganeti/HTools/Backend \
72         src/Ganeti/HTools/Program \
73         src/Ganeti/Hypervisor \
74         src/Ganeti/Hypervisor/Xen \
75         src/Ganeti/Monitoring \
76         src/Ganeti/Query \
77         test/hs \
78         test/hs/Test \
79         test/hs/Test/Ganeti \
80         test/hs/Test/Ganeti/Block \
81         test/hs/Test/Ganeti/Block/Drbd \
82         test/hs/Test/Ganeti/Confd \
83         test/hs/Test/Ganeti/HTools \
84         test/hs/Test/Ganeti/HTools/Backend \
85         test/hs/Test/Ganeti/Hypervisor \
86         test/hs/Test/Ganeti/Hypervisor/Xen \
87         test/hs/Test/Ganeti/Query
88
89 # Haskell directories without the roots (src, test/hs)
90 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
91
92 DIRS = \
93         $(HS_DIRS) \
94         autotools \
95         daemons \
96         devel \
97         devel/data \
98         doc \
99         doc/css \
100         doc/examples \
101         doc/examples/gnt-debug \
102         doc/examples/hooks \
103         test/data/htools \
104         test/data/htools/rapi \
105         test/hs/shelltests \
106         lib \
107         lib/build \
108         lib/client \
109         lib/confd \
110         lib/http \
111         lib/hypervisor \
112         lib/block \
113         lib/impexpd \
114         lib/masterd \
115         lib/rapi \
116         lib/server \
117         lib/tools \
118         lib/utils \
119         lib/watcher \
120         man \
121         qa \
122         test \
123         test/data \
124         test/data/bdev-rbd \
125         test/data/ovfdata \
126         test/data/ovfdata/other \
127         test/py \
128         tools
129
130 ALL_APIDOC_HS_DIRS = \
131         $(APIDOC_HS_DIR) \
132         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
133
134 BUILDTIME_DIR_AUTOCREATE = \
135         scripts \
136         $(APIDOC_DIR) \
137         $(ALL_APIDOC_HS_DIRS) \
138         $(APIDOC_PY_DIR) \
139         $(COVERAGE_DIR) \
140         $(COVERAGE_HS_DIR) \
141         $(COVERAGE_PY_DIR) \
142         .hpc
143
144 BUILDTIME_DIRS = \
145         $(BUILDTIME_DIR_AUTOCREATE) \
146         doc/html \
147         doc/man-html
148
149 DIRCHECK_EXCLUDE = \
150         $(BUILDTIME_DIRS) \
151         ganeti-[0-9]*.[0-9]*.[0-9]* \
152         doc/html/_* \
153         doc/man-html/_* \
154         autom4te.cache
155
156 # some helper vars
157 COVERAGE_DIR = doc/coverage
158 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
159 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
160 APIDOC_DIR = doc/api
161 APIDOC_PY_DIR = $(APIDOC_DIR)/py
162 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
163
164 MAINTAINERCLEANFILES = \
165         $(maninput) \
166         doc/install-quick.rst \
167         doc/news.rst \
168         doc/upgrade.rst \
169         vcs-version
170
171 maintainer-clean-local:
172         rm -rf $(BUILDTIME_DIRS)
173
174 CLEANFILES = \
175         $(addsuffix /*.py[co],$(DIRS)) \
176         $(addsuffix /*.hi,$(HS_DIRS)) \
177         $(addsuffix /*.o,$(HS_DIRS)) \
178         $(PYTHON_BOOTSTRAP) \
179         epydoc.conf \
180         $(REPLACE_VARS_SED) \
181         $(SHELL_ENV_INIT) \
182         daemons/daemon-util \
183         daemons/ganeti-cleaner \
184         devel/squeeze-amd64.tar.gz \
185         devel/squeeze-amd64.conf \
186         $(mandocrst) \
187         doc/manpages-enabled.rst \
188         $(BUILT_EXAMPLES) \
189         doc/examples/bash_completion \
190         doc/examples/bash_completion-debug \
191         lib/_generated_rpc.py \
192         $(man_MANS) \
193         $(manhtml) \
194         tools/kvm-ifup \
195         tools/users-setup \
196         tools/vcluster-setup \
197         stamp-directories \
198         stamp-srclinks \
199         $(nodist_pkgpython_PYTHON) \
200         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
201         $(HS_BUILT_TEST_HELPERS) \
202         src/ganeti-confd \
203         src/ganeti-mond \
204         .hpc/*.mix src/*.tix test/hs/*.tix \
205         doc/hs-lint.html
206
207 GENERATED_FILES = \
208         $(built_base_sources) \
209         $(BUILT_PYTHON_SOURCES) \
210         $(PYTHON_BOOTSTRAP)
211
212 HS_GENERATED_FILES =
213 if WANT_HTOOLS
214 HS_GENERATED_FILES += $(HS_PROGS)
215 if ENABLE_CONFD
216 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
217 endif
218
219 if ENABLE_MOND
220 HS_GENERATED_FILES += src/ganeti-mond
221 endif
222 endif
223
224 built_base_sources = \
225         stamp-directories \
226         stamp-srclinks
227
228 built_python_base_sources = \
229         lib/_autoconf.py \
230         lib/_vcsversion.py
231
232 BUILT_PYTHON_SOURCES = \
233         $(built_python_base_sources) \
234         lib/_generated_rpc.py
235
236 # Generating the RPC wrappers depends on many things, so make sure
237 # it's built at the end of the built sources
238 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
239
240 # these are all built from the underlying %.in sources
241 BUILT_EXAMPLES = \
242         doc/examples/ganeti-kvm-poweroff.initd \
243         doc/examples/ganeti.cron \
244         doc/examples/ganeti.initd \
245         doc/examples/ganeti-master-role.ocf \
246         doc/examples/ganeti-node-role.ocf \
247         doc/examples/gnt-config-backup \
248         doc/examples/hooks/ipsec
249
250 nodist_pkgpython_PYTHON = \
251         $(BUILT_PYTHON_SOURCES)
252
253 noinst_PYTHON = \
254         lib/build/__init__.py \
255         lib/build/shell_example_lexer.py \
256         lib/build/sphinx_ext.py
257
258 pkgpython_PYTHON = \
259         lib/__init__.py \
260         lib/asyncnotifier.py \
261         lib/backend.py \
262         lib/bootstrap.py \
263         lib/cli.py \
264         lib/cmdlib.py \
265         lib/compat.py \
266         lib/config.py \
267         lib/constants.py \
268         lib/daemon.py \
269         lib/errors.py \
270         lib/hooksmaster.py \
271         lib/ht.py \
272         lib/jqueue.py \
273         lib/jstore.py \
274         lib/locking.py \
275         lib/luxi.py \
276         lib/mcpu.py \
277         lib/netutils.py \
278         lib/objects.py \
279         lib/opcodes.py \
280         lib/outils.py \
281         lib/ovf.py \
282         lib/pathutils.py \
283         lib/qlang.py \
284         lib/query.py \
285         lib/rpc.py \
286         lib/rpc_defs.py \
287         lib/runtime.py \
288         lib/serializer.py \
289         lib/ssconf.py \
290         lib/ssh.py \
291         lib/storage.py \
292         lib/uidpool.py \
293         lib/vcluster.py \
294         lib/network.py \
295         lib/workerpool.py
296
297 client_PYTHON = \
298         lib/client/__init__.py \
299         lib/client/gnt_backup.py \
300         lib/client/gnt_cluster.py \
301         lib/client/gnt_debug.py \
302         lib/client/gnt_group.py \
303         lib/client/gnt_instance.py \
304         lib/client/gnt_job.py \
305         lib/client/gnt_node.py \
306         lib/client/gnt_network.py \
307         lib/client/gnt_os.py \
308         lib/client/gnt_storage.py
309
310 hypervisor_PYTHON = \
311         lib/hypervisor/__init__.py \
312         lib/hypervisor/hv_base.py \
313         lib/hypervisor/hv_chroot.py \
314         lib/hypervisor/hv_fake.py \
315         lib/hypervisor/hv_kvm.py \
316         lib/hypervisor/hv_lxc.py \
317         lib/hypervisor/hv_xen.py
318
319 block_PYTHON = \
320         lib/block/__init__.py \
321         lib/block/bdev.py \
322         lib/block/base.py \
323         lib/block/drbd.py \
324         lib/block/drbd_info.py \
325         lib/block/drbd_cmdgen.py
326
327 rapi_PYTHON = \
328         lib/rapi/__init__.py \
329         lib/rapi/baserlib.py \
330         lib/rapi/client.py \
331         lib/rapi/client_utils.py \
332         lib/rapi/connector.py \
333         lib/rapi/rlib2.py \
334         lib/rapi/testutils.py
335
336 http_PYTHON = \
337         lib/http/__init__.py \
338         lib/http/auth.py \
339         lib/http/client.py \
340         lib/http/server.py
341
342 confd_PYTHON = \
343         lib/confd/__init__.py \
344         lib/confd/client.py
345
346 masterd_PYTHON = \
347         lib/masterd/__init__.py \
348         lib/masterd/iallocator.py \
349         lib/masterd/instance.py
350
351 impexpd_PYTHON = \
352         lib/impexpd/__init__.py
353
354 watcher_PYTHON = \
355         lib/watcher/__init__.py \
356         lib/watcher/nodemaint.py \
357         lib/watcher/state.py
358
359 server_PYTHON = \
360         lib/server/__init__.py \
361         lib/server/masterd.py \
362         lib/server/noded.py \
363         lib/server/rapi.py
364
365 pytools_PYTHON = \
366         lib/tools/__init__.py \
367         lib/tools/burnin.py \
368         lib/tools/ensure_dirs.py \
369         lib/tools/node_cleanup.py \
370         lib/tools/node_daemon_setup.py \
371         lib/tools/prepare_node_join.py
372
373 utils_PYTHON = \
374         lib/utils/__init__.py \
375         lib/utils/algo.py \
376         lib/utils/filelock.py \
377         lib/utils/hash.py \
378         lib/utils/io.py \
379         lib/utils/log.py \
380         lib/utils/lvm.py \
381         lib/utils/mlock.py \
382         lib/utils/nodesetup.py \
383         lib/utils/process.py \
384         lib/utils/retry.py \
385         lib/utils/storage.py \
386         lib/utils/text.py \
387         lib/utils/wrapper.py \
388         lib/utils/x509.py
389
390 docinput = \
391         doc/conf.py \
392         doc/css/style.css \
393         doc/admin.rst \
394         doc/cluster-merge.rst \
395         doc/design-2.0.rst \
396         doc/design-2.1.rst \
397         doc/design-2.2.rst \
398         doc/design-2.3.rst \
399         doc/design-2.4.rst \
400         doc/design-2.5.rst \
401         doc/design-2.6.rst \
402         doc/design-2.7.rst \
403         doc/design-autorepair.rst \
404         doc/design-bulk-create.rst \
405         doc/design-chained-jobs.rst \
406         doc/design-cpu-pinning.rst \
407         doc/design-device-uuid-name.rst \
408         doc/design-draft.rst \
409         doc/design-htools-2.3.rst \
410         doc/design-http-server.rst \
411         doc/design-impexp2.rst \
412         doc/design-lu-generated-jobs.rst \
413         doc/design-linuxha.rst \
414         doc/design-multi-reloc.rst \
415         doc/design-network.rst \
416         doc/design-node-add.rst \
417         doc/design-oob.rst \
418         doc/design-ovf-support.rst \
419         doc/design-opportunistic-locking.rst \
420         doc/design-partitioned.rst \
421         doc/design-query-splitting.rst \
422         doc/design-query2.rst \
423         doc/design-reason-trail.rst \
424         doc/design-resource-model.rst \
425         doc/design-restricted-commands.rst \
426         doc/design-shared-storage.rst \
427         doc/design-monitoring-agent.rst \
428         doc/design-virtual-clusters.rst \
429         doc/design-x509-ca.rst \
430         doc/design-hroller.rst \
431         doc/design-storagetypes.rst \
432         doc/devnotes.rst \
433         doc/glossary.rst \
434         doc/hooks.rst \
435         doc/iallocator.rst \
436         doc/index.rst \
437         doc/install-quick.rst \
438         doc/install.rst \
439         doc/locking.rst \
440         doc/manpages-disabled.rst \
441         doc/move-instance.rst \
442         doc/news.rst \
443         doc/ovfconverter.rst \
444         doc/rapi.rst \
445         doc/security.rst \
446         doc/upgrade.rst \
447         doc/virtual-cluster.rst \
448         doc/walkthrough.rst
449
450 # Generates file names such as "doc/man-gnt-instance.rst"
451 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
452
453 # Haskell programs to be installed in $PREFIX/bin
454 HS_BIN_PROGS=src/htools
455
456 # Haskell programs to be installed in the MYEXECLIB dir
457 if ENABLE_MOND
458 HS_MYEXECLIB_PROGS=src/mon-collector
459 else
460 HS_MYEXECLIB_PROGS=
461 endif
462
463 # Haskell programs to be compiled by "make really-all"
464 HS_COMPILE_PROGS= \
465         src/ganeti-mond \
466         src/hconfd \
467         src/rpc-test
468
469 # All Haskell non-test programs to be compiled but not automatically installed
470 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
471
472 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
473 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
474
475 HS_ALL_PROGS = \
476         $(HS_PROGS) \
477         test/hs/hpc-htools \
478         test/hs/hpc-mon-collector \
479         test/hs/htest \
480         $(HS_COMPILE_PROGS)
481
482 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
483 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
484
485 HFLAGS = \
486         -O -Wall -Werror -isrc \
487         -fwarn-monomorphism-restriction \
488         -fwarn-tabs \
489         $(GHC_BYVERSION_FLAGS)
490
491 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
492 HEXTRA =
493 # internal extra flags (used for test/hs/htest mainly)
494 HEXTRA_INT =
495 # exclude options for coverage reports
496 HPCEXCL = --exclude Main \
497         --exclude Ganeti.Constants \
498         --exclude Ganeti.HTools.QC \
499         --exclude Ganeti.THH \
500         --exclude Ganeti.Version \
501         --exclude Test.Ganeti.Attoparsec \
502         --exclude Test.Ganeti.TestCommon \
503         --exclude Test.Ganeti.TestHTools \
504         --exclude Test.Ganeti.TestHelper \
505         --exclude Test.Ganeti.TestImports \
506         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
507
508 HS_LIB_SRCS = \
509         src/Ganeti/Block/Drbd/Types.hs \
510         src/Ganeti/Block/Drbd/Parser.hs \
511         src/Ganeti/BasicTypes.hs \
512         src/Ganeti/Common.hs \
513         src/Ganeti/Compat.hs \
514         src/Ganeti/Confd/Client.hs \
515         src/Ganeti/Confd/Server.hs \
516         src/Ganeti/Confd/Types.hs \
517         src/Ganeti/Confd/Utils.hs \
518         src/Ganeti/Config.hs \
519         src/Ganeti/Curl/Multi.hs \
520         src/Ganeti/Daemon.hs \
521         src/Ganeti/DataCollectors/CLI.hs \
522         src/Ganeti/DataCollectors/Drbd.hs \
523         src/Ganeti/DataCollectors/Program.hs \
524         src/Ganeti/DataCollectors/Types.hs \
525         src/Ganeti/Errors.hs \
526         src/Ganeti/HTools/Backend/IAlloc.hs \
527         src/Ganeti/HTools/Backend/Luxi.hs \
528         src/Ganeti/HTools/Backend/Rapi.hs \
529         src/Ganeti/HTools/Backend/Simu.hs \
530         src/Ganeti/HTools/Backend/Text.hs \
531         src/Ganeti/HTools/CLI.hs \
532         src/Ganeti/HTools/Cluster.hs \
533         src/Ganeti/HTools/Container.hs \
534         src/Ganeti/HTools/ExtLoader.hs \
535         src/Ganeti/HTools/Graph.hs \
536         src/Ganeti/HTools/Group.hs \
537         src/Ganeti/HTools/Instance.hs \
538         src/Ganeti/HTools/Loader.hs \
539         src/Ganeti/HTools/Node.hs \
540         src/Ganeti/HTools/PeerMap.hs \
541         src/Ganeti/HTools/Program/Hail.hs \
542         src/Ganeti/HTools/Program/Harep.hs \
543         src/Ganeti/HTools/Program/Hbal.hs \
544         src/Ganeti/HTools/Program/Hcheck.hs \
545         src/Ganeti/HTools/Program/Hinfo.hs \
546         src/Ganeti/HTools/Program/Hscan.hs \
547         src/Ganeti/HTools/Program/Hspace.hs \
548         src/Ganeti/HTools/Program/Hroller.hs \
549         src/Ganeti/HTools/Program/Main.hs \
550         src/Ganeti/HTools/Types.hs \
551         src/Ganeti/Hypervisor/Xen.hs \
552         src/Ganeti/Hypervisor/Xen/XmParser.hs \
553         src/Ganeti/Hypervisor/Xen/Types.hs \
554         src/Ganeti/Hash.hs \
555         src/Ganeti/JQueue.hs \
556         src/Ganeti/JSON.hs \
557         src/Ganeti/Jobs.hs \
558         src/Ganeti/Logging.hs \
559         src/Ganeti/Luxi.hs \
560         src/Ganeti/Monitoring/Server.hs \
561         src/Ganeti/Network.hs \
562         src/Ganeti/Objects.hs \
563         src/Ganeti/OpCodes.hs \
564         src/Ganeti/OpParams.hs \
565         src/Ganeti/Path.hs \
566         src/Ganeti/Query/Common.hs \
567         src/Ganeti/Query/Export.hs \
568         src/Ganeti/Query/Filter.hs \
569         src/Ganeti/Query/Group.hs \
570         src/Ganeti/Query/Job.hs \
571         src/Ganeti/Query/Language.hs \
572         src/Ganeti/Query/Network.hs \
573         src/Ganeti/Query/Node.hs \
574         src/Ganeti/Query/Query.hs \
575         src/Ganeti/Query/Server.hs \
576         src/Ganeti/Query/Types.hs \
577         src/Ganeti/Rpc.hs \
578         src/Ganeti/Runtime.hs \
579         src/Ganeti/Ssconf.hs \
580         src/Ganeti/THH.hs \
581         src/Ganeti/Types.hs \
582         src/Ganeti/Utils.hs
583
584 HS_TEST_SRCS = \
585         test/hs/Test/Ganeti/Attoparsec.hs \
586         test/hs/Test/Ganeti/BasicTypes.hs \
587         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
588         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
589         test/hs/Test/Ganeti/Common.hs \
590         test/hs/Test/Ganeti/Confd/Types.hs \
591         test/hs/Test/Ganeti/Confd/Utils.hs \
592         test/hs/Test/Ganeti/Daemon.hs \
593         test/hs/Test/Ganeti/Errors.hs \
594         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
595         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
596         test/hs/Test/Ganeti/HTools/CLI.hs \
597         test/hs/Test/Ganeti/HTools/Cluster.hs \
598         test/hs/Test/Ganeti/HTools/Container.hs \
599         test/hs/Test/Ganeti/HTools/Graph.hs \
600         test/hs/Test/Ganeti/HTools/Instance.hs \
601         test/hs/Test/Ganeti/HTools/Loader.hs \
602         test/hs/Test/Ganeti/HTools/Node.hs \
603         test/hs/Test/Ganeti/HTools/PeerMap.hs \
604         test/hs/Test/Ganeti/HTools/Types.hs \
605         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
606         test/hs/Test/Ganeti/JSON.hs \
607         test/hs/Test/Ganeti/Jobs.hs \
608         test/hs/Test/Ganeti/JQueue.hs \
609         test/hs/Test/Ganeti/Luxi.hs \
610         test/hs/Test/Ganeti/Network.hs \
611         test/hs/Test/Ganeti/Objects.hs \
612         test/hs/Test/Ganeti/OpCodes.hs \
613         test/hs/Test/Ganeti/Query/Filter.hs \
614         test/hs/Test/Ganeti/Query/Language.hs \
615         test/hs/Test/Ganeti/Query/Network.hs \
616         test/hs/Test/Ganeti/Query/Query.hs \
617         test/hs/Test/Ganeti/Rpc.hs \
618         test/hs/Test/Ganeti/Runtime.hs \
619         test/hs/Test/Ganeti/Ssconf.hs \
620         test/hs/Test/Ganeti/THH.hs \
621         test/hs/Test/Ganeti/TestCommon.hs \
622         test/hs/Test/Ganeti/TestHTools.hs \
623         test/hs/Test/Ganeti/TestHelper.hs \
624         test/hs/Test/Ganeti/Types.hs \
625         test/hs/Test/Ganeti/Utils.hs
626
627 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
628
629 HS_BUILT_SRCS = \
630         test/hs/Test/Ganeti/TestImports.hs \
631         src/Ganeti/Constants.hs \
632         src/Ganeti/Curl/Internal.hs \
633         src/Ganeti/Version.hs
634 HS_BUILT_SRCS_IN = \
635         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
636         src/Ganeti/Curl/Internal.hsc
637
638 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
639
640 $(RUN_IN_TEMPDIR): | stamp-directories
641
642 doc/html/index.html: ENABLE_MANPAGES =
643 doc/man-html/index.html: ENABLE_MANPAGES = 1
644 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
645
646 # Note: we use here an order-only prerequisite, as the contents of
647 # _autoconf.py are not actually influencing the html build output: it
648 # has to exist in order for the sphinx module to be loaded
649 # successfully, but we certainly don't want the docs to be rebuilt if
650 # it changes
651 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
652         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
653         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
654         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
655         | $(BUILT_PYTHON_SOURCES)
656         @test -n "$(SPHINX)" || \
657             { echo 'sphinx-build' not found during configure; exit 1; }
658 if !MANPAGES_IN_DOC
659         if test -n '$(ENABLE_MANPAGES)'; then \
660           echo 'Man pages in documentation were disabled at configure time' >&2; \
661           exit 1; \
662         fi
663 endif
664 ## Sphinx provides little control over what content should be included. Some
665 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
666 ## build two different versions of the documentation--once without man pages and
667 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
668 ## us with this, but requires running in a temporary directory. It moves the
669 ## correct files into place depending on environment variables.
670         dir=$(dir $@) && \
671         @mkdir_p@ $$dir && \
672         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
673         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
674             -d . \
675             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
676             -D release="$(PACKAGE_VERSION)" \
677             -D graphviz_dot="$(DOT)" \
678             -D enable_manpages="$(ENABLE_MANPAGES)" \
679             doc $(CURDIR)/$$dir && \
680         rm -f $$dir/.buildinfo $$dir/objects.inv
681         touch $@
682
683 doc/html: doc/html/index.html
684
685 doc/man-html: doc/man-html/index.html
686
687 doc/install-quick.rst: INSTALL
688 doc/news.rst: NEWS
689 doc/upgrade.rst: UPGRADE
690
691 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
692         set -e; \
693         { echo '.. This file is automatically updated at build time from $<.'; \
694           echo '.. Do not edit.'; \
695           echo; \
696           cat $<; \
697         } > $@
698
699 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
700         { echo '.. This file is automatically generated, do not edit!'; \
701           echo ''; \
702           echo 'Man pages'; \
703           echo '========='; \
704           echo; \
705           echo '.. toctree::'; \
706           echo '   :maxdepth: 1'; \
707           echo; \
708           for i in $(notdir $(mandocrst)); do \
709             echo "   $$i"; \
710           done | LC_ALL=C sort; \
711         } > $@
712
713 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
714 if MANPAGES_IN_DOC
715         { echo '.. This file is automatically updated at build time from $<.'; \
716           echo '.. Do not edit.'; \
717           echo; \
718           echo "$*"; \
719           echo '=========================================='; \
720           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
721         } > $@
722 else
723         echo 'Man pages in documentation were disabled at configure time' >&2; \
724         exit 1;
725 endif
726
727 # Things to build but not to install (add it to EXTRA_DIST if it should be
728 # distributed)
729 noinst_DATA = \
730         doc/html \
731         $(BUILT_EXAMPLES) \
732         doc/examples/bash_completion \
733         doc/examples/bash_completion-debug \
734         $(manhtml)
735
736 if MANPAGES_IN_DOC
737 noinst_DATA += doc/man-html
738 endif
739
740 gnt_scripts = \
741         scripts/gnt-backup \
742         scripts/gnt-cluster \
743         scripts/gnt-debug \
744         scripts/gnt-group \
745         scripts/gnt-instance \
746         scripts/gnt-job \
747         scripts/gnt-network \
748         scripts/gnt-node \
749         scripts/gnt-os \
750         scripts/gnt-storage
751
752 PYTHON_BOOTSTRAP_SBIN = \
753         daemons/ganeti-masterd \
754         daemons/ganeti-noded \
755         daemons/ganeti-rapi \
756         daemons/ganeti-watcher \
757         $(gnt_scripts)
758
759 PYTHON_BOOTSTRAP = \
760         $(PYTHON_BOOTSTRAP_SBIN) \
761         tools/burnin \
762         tools/ensure-dirs \
763         tools/node-cleanup \
764         tools/node-daemon-setup \
765         tools/prepare-node-join
766
767 qa_scripts = \
768         qa/__init__.py \
769         qa/ganeti-qa.py \
770         qa/qa_cluster.py \
771         qa/qa_config.py \
772         qa/qa_daemon.py \
773         qa/qa_env.py \
774         qa/qa_error.py \
775         qa/qa_group.py \
776         qa/qa_instance.py \
777         qa/qa_job.py \
778         qa/qa_node.py \
779         qa/qa_os.py \
780         qa/qa_rapi.py \
781         qa/qa_tags.py \
782         qa/qa_utils.py
783
784 bin_SCRIPTS =
785 if WANT_HTOOLS
786 bin_SCRIPTS += $(HS_BIN_PROGS)
787 install-exec-hook:
788         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
789 # FIXME: this is a hardcoded logic, instead of auto-resolving
790         $(LN_S) -f ../../../bin/htools \
791           $(DESTDIR)$(iallocatorsdir)/hail
792         for role in $(HS_BIN_ROLES); do \
793           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
794         done
795 endif
796
797 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
798         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
799           echo "Error: cannot run unittests without the development" \
800                " libraries (see devnotes.rst)" 1>&2; \
801           exit 1; \
802         fi
803         @rm -f $(notdir $@).tix
804         $(GHC) --make \
805           $(HFLAGS) \
806           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
807           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
808           $(HEXTRA) $(HEXTRA_INT) $@
809         @touch "$@"
810
811 # for the test/hs/htest binary, we need to enable profiling/coverage
812 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
813
814 # we compile the hpc-htools binary with the program coverage
815 test/hs/hpc-htools: HEXTRA_INT=-fhpc
816
817 # we compile the hpc-mon-collector binary with the program coverage
818 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
819
820 # test dependency
821 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
822
823 # rules for building profiling-enabled versions of the haskell
824 # programs: hs-prof does the full two-step build, whereas
825 # hs-prof-quick does only the final rebuild (hs-prof must have been
826 # run before)
827 .PHONY: hs-prof hs-prof-quick
828 hs-prof:
829         @if [ -z "$(TARGET)" ]; then \
830           echo "You need to define TARGET when running this rule" 1>&2; \
831           exit 1; \
832         fi
833         $(MAKE) $(AM_MAKEFLAGS) clean
834         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
835         rm -f $(HS_ALL_PROGS)
836         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
837
838 hs-prof-quick:
839         @if [ -z "$(TARGET)" ]; then \
840           echo "You need to define TARGET when running this rule" 1>&2; \
841           exit 1; \
842         fi
843         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
844
845 dist_sbin_SCRIPTS = \
846         tools/ganeti-listrunner
847
848 nodist_sbin_SCRIPTS = \
849         $(PYTHON_BOOTSTRAP_SBIN) \
850         daemons/ganeti-cleaner
851
852 if ENABLE_CONFD
853 src/ganeti-confd: src/hconfd
854         cp -f $< $@
855
856 nodist_sbin_SCRIPTS += src/ganeti-confd
857 endif
858
859 if ENABLE_MOND
860 nodist_sbin_SCRIPTS += src/ganeti-mond
861 endif
862
863 python_scripts = \
864         tools/cfgshell \
865         tools/cfgupgrade \
866         tools/cfgupgrade12 \
867         tools/cluster-merge \
868         tools/confd-client \
869         tools/fmtjson \
870         tools/lvmstrap \
871         tools/move-instance \
872         tools/ovfconverter \
873         tools/sanitize-config
874
875 dist_tools_SCRIPTS = \
876         $(python_scripts) \
877         tools/burnin \
878         tools/kvm-console-wrapper \
879         tools/master-ip-setup \
880         tools/xen-console-wrapper
881
882 nodist_tools_python_scripts = \
883         tools/node-cleanup
884
885 nodist_tools_SCRIPTS = \
886         $(nodist_tools_python_scripts) \
887         tools/users-setup \
888         tools/vcluster-setup
889
890 pkglib_python_scripts = \
891         daemons/import-export \
892         tools/check-cert-expired
893
894 nodist_pkglib_python_scripts = \
895         tools/ensure-dirs \
896         tools/node-daemon-setup \
897         tools/prepare-node-join
898
899 myexeclib_SCRIPTS = \
900         daemons/daemon-util \
901         tools/kvm-ifup \
902         $(pkglib_python_scripts) \
903         $(HS_MYEXECLIB_PROGS)
904
905 nodist_myexeclib_SCRIPTS = \
906         $(nodist_pkglib_python_scripts)
907
908 EXTRA_DIST = \
909         NEWS \
910         UPGRADE \
911         epydoc.conf.in \
912         pylintrc \
913         autotools/build-bash-completion \
914         autotools/build-rpc \
915         autotools/check-header \
916         autotools/check-imports \
917         autotools/check-man-dashes \
918         autotools/check-man-references \
919         autotools/check-man-warnings \
920         autotools/check-news \
921         autotools/check-python-code \
922         autotools/check-tar \
923         autotools/check-version \
924         autotools/convert-constants \
925         autotools/docpp \
926         autotools/gen-py-coverage \
927         autotools/sphinx-wrapper \
928         autotools/testrunner \
929         autotools/wrong-hardcoded-paths \
930         $(RUN_IN_TEMPDIR) \
931         daemons/daemon-util.in \
932         daemons/ganeti-cleaner.in \
933         $(pkglib_python_scripts) \
934         devel/upload \
935         devel/webserver \
936         tools/kvm-ifup.in \
937         tools/users-setup.in \
938         tools/vcluster-setup.in \
939         $(docinput) \
940         doc/html \
941         $(BUILT_EXAMPLES:%=%.in) \
942         doc/examples/ganeti.default \
943         doc/examples/ganeti.default-debug \
944         doc/examples/hooks/ethers \
945         doc/examples/gnt-debug/README \
946         doc/examples/gnt-debug/delay0.json \
947         doc/examples/gnt-debug/delay50.json \
948         test/py/lockperf.py \
949         test/py/testutils.py \
950         test/py/mocks.py \
951         $(dist_TESTS) \
952         $(TEST_FILES) \
953         man/footer.rst \
954         $(manrst) \
955         $(maninput) \
956         qa/qa-sample.json \
957         $(qa_scripts) \
958         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
959         $(HS_PROG_SRCS) \
960         src/lint-hints.hs \
961         test/hs/cli-tests-defs.sh \
962         test/hs/offline-test.sh \
963         .ghci
964
965 man_MANS = \
966         man/ganeti-cleaner.8 \
967         man/ganeti-confd.8 \
968         man/ganeti-listrunner.8 \
969         man/ganeti-masterd.8 \
970         man/ganeti-mond.8 \
971         man/ganeti-noded.8 \
972         man/ganeti-os-interface.7 \
973         man/ganeti-extstorage-interface.7 \
974         man/ganeti-rapi.8 \
975         man/ganeti-watcher.8 \
976         man/ganeti.7 \
977         man/gnt-backup.8 \
978         man/gnt-cluster.8 \
979         man/gnt-debug.8 \
980         man/gnt-group.8 \
981         man/gnt-network.8 \
982         man/gnt-instance.8 \
983         man/gnt-job.8 \
984         man/gnt-node.8 \
985         man/gnt-os.8 \
986         man/gnt-storage.8 \
987         man/hail.1 \
988         man/hbal.1 \
989         man/hcheck.1 \
990         man/hinfo.1 \
991         man/hscan.1 \
992         man/hspace.1 \
993         man/hroller.1 \
994         man/htools.1 \
995         man/mon-collector.7
996
997 # Remove extensions from all filenames in man_MANS
998 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
999
1000 manrst = $(patsubst %,%.rst,$(mannoext))
1001 manhtml = $(patsubst %.rst,%.html,$(manrst))
1002 mangen = $(patsubst %.rst,%.gen,$(manrst))
1003 maninput = \
1004         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1005         $(patsubst %.html,%.html.in,$(manhtml)) \
1006         $(mangen)
1007
1008 TEST_FILES = \
1009         test/data/htools/clean-nonzero-score.data \
1010         test/data/htools/common-suffix.data \
1011         test/data/htools/empty-cluster.data \
1012         test/data/htools/hail-alloc-drbd.json \
1013         test/data/htools/hail-alloc-invalid-twodisks.json \
1014         test/data/htools/hail-alloc-twodisks.json \
1015         test/data/htools/hail-change-group.json \
1016         test/data/htools/hail-invalid-reloc.json \
1017         test/data/htools/hail-node-evac.json \
1018         test/data/htools/hail-reloc-drbd.json \
1019         test/data/htools/hbal-excl-tags.data \
1020         test/data/htools/hbal-split-insts.data \
1021         test/data/htools/hspace-tiered-dualspec.data \
1022         test/data/htools/hspace-tiered.data \
1023         test/data/htools/invalid-node.data \
1024         test/data/htools/missing-resources.data \
1025         test/data/htools/multiple-master.data \
1026         test/data/htools/multiple-tags.data \
1027         test/data/htools/n1-failure.data \
1028         test/data/htools/rapi/groups.json \
1029         test/data/htools/rapi/info.json \
1030         test/data/htools/rapi/instances.json \
1031         test/data/htools/rapi/nodes.json \
1032         test/data/htools/hroller-online.data \
1033         test/data/htools/unique-reboot-order.data \
1034         test/hs/shelltests/htools-balancing.test \
1035         test/hs/shelltests/htools-basic.test \
1036         test/hs/shelltests/htools-dynutil.test \
1037         test/hs/shelltests/htools-excl.test \
1038         test/hs/shelltests/htools-hail.test \
1039         test/hs/shelltests/htools-hroller.test \
1040         test/hs/shelltests/htools-hspace.test \
1041         test/hs/shelltests/htools-invalid.test \
1042         test/hs/shelltests/htools-multi-group.test \
1043         test/hs/shelltests/htools-no-backend.test \
1044         test/hs/shelltests/htools-rapi.test \
1045         test/hs/shelltests/htools-single-group.test \
1046         test/hs/shelltests/htools-text-backend.test \
1047         test/hs/shelltests/htools-mon-collector.test \
1048         test/data/bdev-drbd-8.0.txt \
1049         test/data/bdev-drbd-8.3.txt \
1050         test/data/bdev-drbd-8.4.txt \
1051         test/data/bdev-drbd-disk.txt \
1052         test/data/bdev-drbd-net-ip4.txt \
1053         test/data/bdev-drbd-net-ip6.txt \
1054         test/data/bdev-rbd/json_output_empty.txt \
1055         test/data/bdev-rbd/json_output_extra_matches.txt \
1056         test/data/bdev-rbd/json_output_no_matches.txt \
1057         test/data/bdev-rbd/json_output_ok.txt \
1058         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1059         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1060         test/data/bdev-rbd/plain_output_new_ok.txt \
1061         test/data/bdev-rbd/plain_output_old_empty.txt \
1062         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1063         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1064         test/data/bdev-rbd/plain_output_old_ok.txt \
1065         test/data/bdev-rbd/output_invalid.txt \
1066         test/data/cert1.pem \
1067         test/data/cert2.pem \
1068         test/data/cluster_config_2.7.json \
1069         test/data/cluster_config_downgraded_2.7.json \
1070         test/data/instance-minor-pairing.txt \
1071         test/data/ip-addr-show-dummy0.txt \
1072         test/data/ip-addr-show-lo-ipv4.txt \
1073         test/data/ip-addr-show-lo-ipv6.txt \
1074         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1075         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1076         test/data/ip-addr-show-lo-oneline.txt \
1077         test/data/ip-addr-show-lo.txt \
1078         test/data/kvm_0.12.5_help.txt \
1079         test/data/kvm_0.15.90_help.txt \
1080         test/data/kvm_0.9.1_help.txt \
1081         test/data/kvm_0.9.1_help_boot_test.txt \
1082         test/data/kvm_1.0_help.txt \
1083         test/data/kvm_1.1.2_help.txt \
1084         test/data/ovfdata/compr_disk.vmdk.gz \
1085         test/data/ovfdata/config.ini \
1086         test/data/ovfdata/corrupted_resources.ovf \
1087         test/data/ovfdata/empty.ini \
1088         test/data/ovfdata/empty.ovf \
1089         test/data/ovfdata/ganeti.mf \
1090         test/data/ovfdata/ganeti.ovf \
1091         test/data/ovfdata/gzip_disk.ovf \
1092         test/data/ovfdata/new_disk.vmdk \
1093         test/data/ovfdata/no_disk.ini \
1094         test/data/ovfdata/no_disk_in_ref.ovf \
1095         test/data/ovfdata/no_os.ini \
1096         test/data/ovfdata/no_ovf.ova \
1097         test/data/ovfdata/other/rawdisk.raw \
1098         test/data/ovfdata/ova.ova \
1099         test/data/ovfdata/rawdisk.raw \
1100         test/data/ovfdata/second_disk.vmdk \
1101         test/data/ovfdata/unsafe_path.ini \
1102         test/data/ovfdata/virtualbox.ovf \
1103         test/data/ovfdata/wrong_config.ini \
1104         test/data/ovfdata/wrong_extension.ovd \
1105         test/data/ovfdata/wrong_manifest.mf \
1106         test/data/ovfdata/wrong_manifest.ovf \
1107         test/data/ovfdata/wrong_ova.ova \
1108         test/data/ovfdata/wrong_xml.ovf \
1109         test/data/proc_drbd8.txt \
1110         test/data/proc_drbd80-emptyline.txt \
1111         test/data/proc_drbd80-emptyversion.txt \
1112         test/data/proc_drbd83.txt \
1113         test/data/proc_drbd83_sync.txt \
1114         test/data/proc_drbd83_sync_want.txt \
1115         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1116         test/data/proc_drbd84.txt \
1117         test/data/proc_drbd84_sync.txt \
1118         test/data/qa-minimal-nodes-instances-only.json \
1119         test/data/sys_drbd_usermode_helper.txt \
1120         test/data/vgreduce-removemissing-2.02.02.txt \
1121         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1122         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1123         test/data/vgs-missing-pvs-2.02.02.txt \
1124         test/data/vgs-missing-pvs-2.02.66.txt \
1125         test/data/xen-xm-info-4.0.1.txt \
1126         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1127         test/data/xen-xm-list-4.0.1-four-instances.txt \
1128         test/data/xen-xm-list-long-4.0.1.txt \
1129         test/data/xen-xm-uptime-4.0.1.txt \
1130         test/py/ganeti-cli.test \
1131         test/py/gnt-cli.test \
1132         test/py/import-export_unittest-helper
1133
1134 python_tests = \
1135         doc/examples/rapi_testutils.py \
1136         test/py/cfgupgrade_unittest.py \
1137         test/py/docs_unittest.py \
1138         test/py/ganeti.asyncnotifier_unittest.py \
1139         test/py/ganeti.backend_unittest-runasroot.py \
1140         test/py/ganeti.backend_unittest.py \
1141         test/py/ganeti.block.bdev_unittest.py \
1142         test/py/ganeti.block.drbd_unittest.py \
1143         test/py/ganeti.cli_unittest.py \
1144         test/py/ganeti.client.gnt_cluster_unittest.py \
1145         test/py/ganeti.client.gnt_instance_unittest.py \
1146         test/py/ganeti.client.gnt_job_unittest.py \
1147         test/py/ganeti.cmdlib_unittest.py \
1148         test/py/ganeti.compat_unittest.py \
1149         test/py/ganeti.confd.client_unittest.py \
1150         test/py/ganeti.config_unittest.py \
1151         test/py/ganeti.constants_unittest.py \
1152         test/py/ganeti.daemon_unittest.py \
1153         test/py/ganeti.errors_unittest.py \
1154         test/py/ganeti.hooks_unittest.py \
1155         test/py/ganeti.ht_unittest.py \
1156         test/py/ganeti.http_unittest.py \
1157         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1158         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1159         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1160         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1161         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1162         test/py/ganeti.hypervisor_unittest.py \
1163         test/py/ganeti.impexpd_unittest.py \
1164         test/py/ganeti.jqueue_unittest.py \
1165         test/py/ganeti.jstore_unittest.py \
1166         test/py/ganeti.locking_unittest.py \
1167         test/py/ganeti.luxi_unittest.py \
1168         test/py/ganeti.masterd.iallocator_unittest.py \
1169         test/py/ganeti.masterd.instance_unittest.py \
1170         test/py/ganeti.mcpu_unittest.py \
1171         test/py/ganeti.netutils_unittest.py \
1172         test/py/ganeti.objects_unittest.py \
1173         test/py/ganeti.opcodes_unittest.py \
1174         test/py/ganeti.outils_unittest.py \
1175         test/py/ganeti.ovf_unittest.py \
1176         test/py/ganeti.qlang_unittest.py \
1177         test/py/ganeti.query_unittest.py \
1178         test/py/ganeti.rapi.baserlib_unittest.py \
1179         test/py/ganeti.rapi.client_unittest.py \
1180         test/py/ganeti.rapi.resources_unittest.py \
1181         test/py/ganeti.rapi.rlib2_unittest.py \
1182         test/py/ganeti.rapi.testutils_unittest.py \
1183         test/py/ganeti.rpc_unittest.py \
1184         test/py/ganeti.runtime_unittest.py \
1185         test/py/ganeti.serializer_unittest.py \
1186         test/py/ganeti.server.rapi_unittest.py \
1187         test/py/ganeti.ssconf_unittest.py \
1188         test/py/ganeti.ssh_unittest.py \
1189         test/py/ganeti.storage_unittest.py \
1190         test/py/ganeti.tools.burnin_unittest.py \
1191         test/py/ganeti.tools.ensure_dirs_unittest.py \
1192         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1193         test/py/ganeti.tools.prepare_node_join_unittest.py \
1194         test/py/ganeti.uidpool_unittest.py \
1195         test/py/ganeti.utils.algo_unittest.py \
1196         test/py/ganeti.utils.filelock_unittest.py \
1197         test/py/ganeti.utils.hash_unittest.py \
1198         test/py/ganeti.utils.io_unittest-runasroot.py \
1199         test/py/ganeti.utils.io_unittest.py \
1200         test/py/ganeti.utils.log_unittest.py \
1201         test/py/ganeti.utils.lvm_unittest.py \
1202         test/py/ganeti.utils.mlock_unittest.py \
1203         test/py/ganeti.utils.nodesetup_unittest.py \
1204         test/py/ganeti.utils.process_unittest.py \
1205         test/py/ganeti.utils.retry_unittest.py \
1206         test/py/ganeti.utils.text_unittest.py \
1207         test/py/ganeti.utils.wrapper_unittest.py \
1208         test/py/ganeti.utils.x509_unittest.py \
1209         test/py/ganeti.utils_unittest.py \
1210         test/py/ganeti.vcluster_unittest.py \
1211         test/py/ganeti.workerpool_unittest.py \
1212         test/py/pycurl_reset_unittest.py \
1213         test/py/qa.qa_config_unittest.py \
1214         test/py/tempfile_fork_unittest.py
1215
1216 haskell_tests = test/hs/htest
1217
1218 dist_TESTS = \
1219         test/py/check-cert-expired_unittest.bash \
1220         test/py/daemon-util_unittest.bash \
1221         test/py/ganeti-cleaner_unittest.bash \
1222         test/py/import-export_unittest.bash \
1223         test/py/cli-test.bash \
1224         test/py/bash_completion.bash \
1225         $(python_tests)
1226
1227 nodist_TESTS =
1228 check_SCRIPTS =
1229
1230 if WANT_HSTESTS
1231 nodist_TESTS += $(haskell_tests)
1232 dist_TESTS += test/hs/offline-test.sh
1233 check_SCRIPTS += \
1234         test/hs/hpc-htools \
1235         test/hs/hpc-mon-collector \
1236         $(HS_BUILT_TEST_HELPERS)
1237 endif
1238
1239 TESTS = $(dist_TESTS) $(nodist_TESTS)
1240
1241 # Environment for all tests
1242 PLAIN_TESTS_ENVIRONMENT = \
1243         PYTHONPATH=. \
1244         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1245         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1246         $(RUN_IN_TEMPDIR)
1247
1248 # Environment for tests run by automake
1249 TESTS_ENVIRONMENT = \
1250         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1251
1252 all_python_code = \
1253         $(dist_sbin_SCRIPTS) \
1254         $(python_scripts) \
1255         $(pkglib_python_scripts) \
1256         $(nodist_pkglib_python_scripts) \
1257         $(nodist_tools_python_scripts) \
1258         $(python_tests) \
1259         $(pkgpython_PYTHON) \
1260         $(client_PYTHON) \
1261         $(hypervisor_PYTHON) \
1262         $(block_PYTHON) \
1263         $(rapi_PYTHON) \
1264         $(server_PYTHON) \
1265         $(pytools_PYTHON) \
1266         $(http_PYTHON) \
1267         $(confd_PYTHON) \
1268         $(masterd_PYTHON) \
1269         $(impexpd_PYTHON) \
1270         $(utils_PYTHON) \
1271         $(watcher_PYTHON) \
1272         $(noinst_PYTHON) \
1273         $(qa_scripts)
1274
1275 srclink_files = \
1276         man/footer.rst \
1277         test/py/check-cert-expired_unittest.bash \
1278         test/py/daemon-util_unittest.bash \
1279         test/py/ganeti-cleaner_unittest.bash \
1280         test/py/import-export_unittest.bash \
1281         test/py/cli-test.bash \
1282         test/py/bash_completion.bash \
1283         test/hs/offline-test.sh \
1284         test/hs/cli-tests-defs.sh \
1285         $(all_python_code) \
1286         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1287         $(docinput)
1288
1289 check_python_code = \
1290         $(BUILD_BASH_COMPLETION) \
1291         $(CHECK_IMPORTS) \
1292         $(CHECK_HEADER) \
1293         $(DOCPP) \
1294         $(all_python_code)
1295
1296 lint_python_code = \
1297         ganeti \
1298         ganeti/http/server.py \
1299         $(dist_sbin_SCRIPTS) \
1300         $(python_scripts) \
1301         $(pkglib_python_scripts) \
1302         $(BUILD_BASH_COMPLETION) \
1303         $(CHECK_IMPORTS) \
1304         $(CHECK_HEADER) \
1305         $(DOCPP) \
1306         $(PYTHON_BOOTSTRAP)
1307
1308 standalone_python_modules = \
1309         lib/rapi/client.py \
1310         tools/ganeti-listrunner
1311
1312 pep8_python_code = \
1313         ganeti \
1314         ganeti/http/server.py \
1315         $(dist_sbin_SCRIPTS) \
1316         $(python_scripts) \
1317         $(pkglib_python_scripts) \
1318         $(BUILD_BASH_COMPLETION) \
1319         $(CHECK_HEADER) \
1320         $(DOCPP) \
1321         $(PYTHON_BOOTSTRAP) \
1322         qa
1323
1324 test/py/daemon-util_unittest.bash: daemons/daemon-util
1325
1326 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1327
1328 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1329
1330 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1331         sed -f $(REPLACE_VARS_SED) < $< > $@
1332         chmod +x $@
1333
1334 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1335         sed -f $(REPLACE_VARS_SED) < $< > $@
1336         chmod +x $@
1337
1338 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1339         sed -f $(REPLACE_VARS_SED) < $< > $@
1340         chmod +x $@
1341
1342 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1343         sed -f $(REPLACE_VARS_SED) < $< > $@
1344         chmod +x $@
1345
1346 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1347         sed -f $(REPLACE_VARS_SED) < $< > $@
1348
1349 doc/examples/bash_completion: BC_ARGS = --compact
1350 doc/examples/bash_completion-debug: BC_ARGS =
1351
1352 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1353         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1354         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1355         daemons/ganeti-cleaner \
1356         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1357         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1358           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1359
1360 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1361         lib/build/shell_example_lexer.py \
1362         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1363         @echo "Checking $< for hardcoded paths..."
1364         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1365           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1366           exit 1; \
1367         fi
1368         set -e ; \
1369         trap 'echo auto-removing $@; rm $@' EXIT; \
1370         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1371         $(CHECK_MAN_REFERENCES) $@; \
1372         trap - EXIT
1373
1374 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1375         @test -n "$(PANDOC)" || \
1376           { echo 'pandoc' not found during configure; exit 1; }
1377         set -o pipefail -e; \
1378         trap 'echo auto-removing $@; rm $@' EXIT; \
1379         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1380           sed -e 's/\\@/@/g' > $@; \
1381         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1382         $(CHECK_MAN_DASHES) $@; \
1383         trap - EXIT
1384
1385 man/%.html.in: man/%.gen man/footer.rst
1386         @test -n "$(PANDOC)" || \
1387           { echo 'pandoc' not found during configure; exit 1; }
1388         set -o pipefail ; \
1389         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1390           sed -e 's/\\@/@/g' > $@
1391
1392 man/%: man/%.in  $(REPLACE_VARS_SED)
1393         sed -f $(REPLACE_VARS_SED) < $< > $@
1394
1395 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1396         sed -f $(REPLACE_VARS_SED) < $< > $@
1397
1398 vcs-version:
1399         if test -d .git; then \
1400           git describe > $@; \
1401         elif test ! -f $@ ; then \
1402           echo "Cannot auto-generate $@ file"; exit 1; \
1403         fi
1404
1405 .PHONY: clean-vcs-version
1406 clean-vcs-version:
1407         rm -f vcs-version
1408
1409 .PHONY: regen-vcs-version
1410 regen-vcs-version:
1411         @set -e; \
1412         cd $(srcdir); \
1413         if test -d .git; then \
1414           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1415           git describe > $$T; \
1416           if ! cmp --quiet $$T vcs-version; then \
1417             mv $$T vcs-version; \
1418           fi; \
1419         fi
1420
1421 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1422         vcs-version $(built_base_sources)
1423         set -e; \
1424         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1425         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1426
1427 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1428         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1429         lib/jstore.py $(RUN_IN_TEMPDIR) \
1430         $(CONVERT_CONSTANTS) $(built_base_sources) \
1431         | lib/_vcsversion.py
1432         set -e; \
1433         { cat $< ; \
1434           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1435         } > $@
1436
1437 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1438         hsc2hs -o $@ $<
1439
1440 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1441         $(built_base_sources)
1442         set -e; \
1443         { cat $< ; \
1444           echo ; \
1445           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1446             echo "import $$name ()" ; \
1447           done ; \
1448         } > $@
1449
1450 lib/_autoconf.py: Makefile | stamp-directories
1451         set -e; \
1452         { echo '# This file is automatically generated, do not edit!'; \
1453           echo '#'; \
1454           echo ''; \
1455           echo '"""Build-time configuration for Ganeti.'; \
1456           echo '';\
1457           echo 'This file is autogenerated by the build process.'; \
1458           echo 'For any changes you need to re-run ./configure (and'; \
1459           echo 'not edit by hand).'; \
1460           echo ''; \
1461           echo '"""'; \
1462           echo ''; \
1463           echo '# pylint: disable=C0301,C0324'; \
1464           echo '# because this is autogenerated, we do not want'; \
1465           echo '# style warnings' ; \
1466           echo ''; \
1467           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1468           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1469           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1470           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1471           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1472           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1473           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1474           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1475           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1476           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1477           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1478           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1479           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1480           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1481           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1482           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1483           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1484           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1485           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1486           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1487           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1488           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1489           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1490           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1491           echo "KVM_PATH = '$(KVM_PATH)'"; \
1492           echo "IP_PATH = '$(IP_PATH)'"; \
1493           echo "SOCAT_PATH = '$(SOCAT)'"; \
1494           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1495           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1496           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1497           echo "TOOLSDIR = '$(toolsdir)'"; \
1498           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1499           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1500           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1501           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1502           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1503           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1504           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1505           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1506           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1507           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1508           echo "RAPI_USER = '$(RAPI_USER)'"; \
1509           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1510           echo "CONFD_USER = '$(CONFD_USER)'"; \
1511           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1512           echo "NODED_USER = '$(NODED_USER)'"; \
1513           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1514           echo "MOND_USER = '$(MOND_USER)'"; \
1515           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1516           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1517           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1518           echo "HTOOLS = True"; \
1519           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1520           echo "XEN_CMD = '$(XEN_CMD)'"; \
1521           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1522           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1523           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1524 ## Write dictionary with man page name as the key and the section number as the
1525 ## value
1526           echo "MAN_PAGES = {"; \
1527           for i in $(notdir $(man_MANS)); do \
1528             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1529           done; \
1530           echo "}"; \
1531         } > $@
1532
1533 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1534         set -e; \
1535         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1536         { echo '# This file is automatically generated, do not edit!'; \
1537           echo '#'; \
1538           echo ''; \
1539           echo '"""Build-time VCS version number for Ganeti.'; \
1540           echo '';\
1541           echo 'This file is autogenerated by the build process.'; \
1542           echo 'For any changes you need to re-run ./configure (and'; \
1543           echo 'not edit by hand).'; \
1544           echo ''; \
1545           echo '"""'; \
1546           echo ''; \
1547           echo '# pylint: disable=C0301,C0324'; \
1548           echo '# because this is autogenerated, we do not want'; \
1549           echo '# style warnings' ; \
1550           echo ''; \
1551           echo "VCS_VERSION = '$$VCSVER'"; \
1552         } > $@
1553
1554 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1555         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1556
1557 $(SHELL_ENV_INIT): Makefile stamp-directories
1558         set -e; \
1559         { echo '# Allow overriding for tests'; \
1560           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1561           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1562           echo; \
1563           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1564           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1565           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1566           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1567           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1568         } > $@
1569
1570 ## Writes sed script to replace placeholders with build-time values. The
1571 ## additional quotes after the first @ sign are necessary to stop configure
1572 ## from replacing those values as well.
1573 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1574         set -e; \
1575         { echo 's#@''PREFIX@#$(prefix)#g'; \
1576           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1577           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1578           echo 's#@''BINDIR@#$(bindir)#g'; \
1579           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1580           echo 's#@''LIBDIR@#$(libdir)#g'; \
1581           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1582           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1583           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1584           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1585           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1586           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1587           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1588           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1589           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1590           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1591           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1592           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1593           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1594           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1595           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1596           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1597           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1598           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1599           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1600           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1601           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1602           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1603           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1604           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1605           echo; \
1606           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1607           echo '  r $(SHELL_ENV_INIT)'; \
1608           echo '  d'; \
1609           echo '}'; \
1610         } > $@
1611
1612 # Using deferred evaluation
1613 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1614 daemons/ganeti-watcher: MODULE = ganeti.watcher
1615 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1616 tools/burnin: MODULE = ganeti.tools.burnin
1617 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1618 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1619 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1620 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1621 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1622
1623 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1624         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1625         set -e; \
1626         { echo '#!/usr/bin/python'; \
1627           echo '# This file is automatically generated, do not edit!'; \
1628           echo "# Edit $(MODULE) instead."; \
1629           echo; \
1630           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1631           echo; \
1632           echo '# pylint: disable=C0103'; \
1633           echo '# C0103: Invalid name'; \
1634           echo; \
1635           echo 'import sys'; \
1636           echo 'import $(MODULE) as main'; \
1637           echo; \
1638           echo '# Temporarily alias commands until bash completion'; \
1639           echo '# generator is changed'; \
1640           echo 'if hasattr(main, "commands"):'; \
1641           echo '  commands = main.commands # pylint: disable=E1101'; \
1642           echo 'if hasattr(main, "aliases"):'; \
1643           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1644           echo; \
1645           echo 'if __name__ == "__main__":'; \
1646           echo '  sys.exit(main.Main())'; \
1647         } > $@
1648         chmod u+x $@
1649
1650 $(HS_BUILT_TEST_HELPERS): Makefile
1651         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1652         set -e; \
1653         { echo '#!/bin/sh'; \
1654           echo '# This file is automatically generated, do not edit!'; \
1655           echo "# Edit Makefile.am instead."; \
1656           echo; \
1657           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1658         } > $@
1659         chmod u+x $@
1660
1661 stamp-directories: Makefile
1662         $(MAKE) $(AM_MAKEFLAGS) ganeti
1663         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1664         touch $@
1665
1666 # We need to create symlinks because "make distcheck" will not install Python
1667 # files when building.
1668 stamp-srclinks: Makefile | stamp-directories
1669         set -e; \
1670         for i in $(srclink_files); do \
1671           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1672             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1673           fi; \
1674         done
1675         touch $@
1676
1677 .PHONY: ganeti
1678 ganeti:
1679         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1680
1681 .PHONY: check-dirs
1682 check-dirs: $(GENERATED_FILES)
1683         @set -e; \
1684         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1685           error=; \
1686           while read dir; do \
1687             case "$$dir" in \
1688               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1689               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1690             esac; \
1691           done; \
1692           for dir in $(DIRS); do \
1693             if ! test -d "$$dir"; then \
1694               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1695               error=1; \
1696             fi \
1697           done; \
1698           test -z "$$error"; \
1699         }
1700
1701 .PHONY: check-local
1702 check-local: check-dirs $(GENERATED_FILES)
1703         $(CHECK_PYTHON_CODE) $(check_python_code)
1704         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1705         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1706         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1707         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1708         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1709         error= ; \
1710         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1711           echo "Incorrect version in README, expected $$expver" >&2; \
1712           error=1; \
1713         fi; \
1714         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1715             doc/security.rst; do \
1716           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1717             "Documents Ganeti version $$expver"; then \
1718             echo "Incorrect version in $$file, expected $$expver" >&2; \
1719             error=1; \
1720           fi; \
1721         done; \
1722         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1723           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1724           error=1; \
1725         fi; \
1726         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1727           ".. Last updated for Ganeti $$expver"; then \
1728           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1729           error=1; \
1730         fi; \
1731         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1732           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1733             echo "Longest line in $$file is longer than 80 characters" >&2; \
1734             error=1; \
1735           fi; \
1736         done; \
1737         test -z "$$error"
1738
1739 .PHONY: hs-tests
1740 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1741         @rm -f htest.tix
1742         ./test/hs/htest
1743
1744 .PHONY: hs-shell
1745 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1746         @rm -f hpc-htools.tix hpc-mon-collector.tix
1747         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1748
1749 .PHONY: hs-check
1750 hs-check: hs-tests hs-shell
1751
1752 # E111: indentation is not a multiple of four
1753 # E121: continuation line indentation is not a multiple of four
1754 #       (since our indent level is not 4)
1755 # E125: continuation line does not distinguish itself from next logical line
1756 #       (since our indent level is not 4)
1757 # E127: continuation line over-indented for visual indent
1758 #       (since our indent level is not 4)
1759 # note: do NOT add E128 here; it's a valid style error in most cases!
1760 # I've seen real errors, but also some cases were we indent wrongly
1761 # due to line length; try to rework the cases where it is triggered,
1762 # instead of silencing it
1763 # E261: at least two spaces before inline comment
1764 # E501: line too long (80 characters)
1765 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1766
1767 # For excluding pep8 expects filenames only, not whole paths
1768 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1769
1770 LINT_TARGETS = pylint pylint-qa
1771 if HAS_PEP8
1772 LINT_TARGETS += pep8
1773 endif
1774 if HAS_HLINT
1775 LINT_TARGETS += hlint
1776 endif
1777
1778 .PHONY: lint
1779 lint: $(LINT_TARGETS)
1780
1781 .PHONY: pylint
1782 pylint: $(GENERATED_FILES)
1783         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1784         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1785
1786 .PHONY: pylint-qa
1787 pylint-qa: $(GENERATED_FILES)
1788         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1789         cd $(top_srcdir)/qa && \
1790           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1791           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1792
1793 .PHONY: pep8
1794 pep8: $(GENERATED_FILES)
1795         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1796         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1797           --repeat $(pep8_python_code)
1798
1799 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1800 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1801 .PHONY: hlint
1802 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1803         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1804         @rm -f doc/hs-lint.html
1805         if tty -s; then C="-c"; else C=""; fi; \
1806         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1807           --ignore "Use first" \
1808           --ignore "Use &&&" \
1809           --ignore "Use void" \
1810           --ignore "Reduce duplication" \
1811           --hint src/lint-hints \
1812           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1813         @if [ ! -f doc/hs-lint.html ]; then \
1814           echo "All good" > doc/hs-lint.html; \
1815         fi
1816
1817 # a dist hook rule for updating the vcs-version file; this is
1818 # hardcoded due to where it needs to build the file...
1819 dist-hook:
1820         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1821         rm -f $(top_distdir)/vcs-version
1822         cp -p $(srcdir)/vcs-version $(top_distdir)
1823
1824 # a distcheck hook rule for catching revision control directories
1825 distcheck-hook:
1826         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1827           echo "Found revision control files in final archive." 1>&2; \
1828           exit 1; \
1829         fi
1830         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1831           echo "Found Python byte code in final archive." 1>&2; \
1832           exit 1; \
1833         fi
1834         if find $(top_distdir) -name '*~' | grep .; then \
1835           echo "Found backup files in final archive." 1>&2; \
1836           exit 1; \
1837         fi
1838 # Empty files or directories should not be distributed. They can cause
1839 # unnecessary warnings for packagers. Directories used by automake during
1840 # distcheck must be excluded.
1841         if find $(top_distdir) -empty -and -not \( \
1842             -path $(top_distdir)/_build -or \
1843             -path $(top_distdir)/_inst \) | grep .; then \
1844           echo "Found empty files or directories in final archive." 1>&2; \
1845           exit 1; \
1846         fi
1847         if test -e $(top_distdir)/doc/man-html; then \
1848           echo "Found documentation including man pages in final archive" >&2; \
1849           exit 1; \
1850         fi
1851
1852 # Backwards compatible distcheck-release target
1853 distcheck-release: distcheck
1854
1855 distrebuildcheck: dist
1856         set -e; \
1857         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1858         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1859         cd $$builddir; \
1860         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1861         cd $(distdir); \
1862         ./configure; \
1863         $(MAKE) maintainer-clean; \
1864         cp $(abs_srcdir)/vcs-version .; \
1865         ./configure; \
1866         $(MAKE) $(AM_MAKEFLAGS)
1867
1868 dist-release: dist
1869         set -e; \
1870         for i in $(DIST_ARCHIVES); do \
1871           echo -n "Checking $$i ... "; \
1872           autotools/check-tar < $$i; \
1873           echo OK; \
1874         done
1875
1876 install-exec-local:
1877         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1878           "$(DESTDIR)${localstatedir}/log/ganeti" \
1879           "$(DESTDIR)${localstatedir}/run/ganeti"
1880
1881 .PHONY: apidoc
1882 if WANT_HSAPIDOC
1883 apidoc: py-apidoc hs-apidoc
1884 else
1885 apidoc: py-apidoc
1886 endif
1887
1888 .PHONY: py-apidoc
1889 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1890         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1891         $(RUN_IN_TEMPDIR) epydoc -v \
1892           --conf $(CURDIR)/epydoc.conf \
1893           --output $(CURDIR)/$(APIDOC_PY_DIR)
1894
1895 .PHONY: hs-apidoc
1896 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1897
1898 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1899         @test -n "$(HSCOLOUR)" || \
1900             { echo 'HsColour' not found during configure; exit 1; }
1901         @test -n "$(HADDOCK)" || \
1902             { echo 'haddock' not found during configure; exit 1; }
1903         rm -rf $(APIDOC_HS_DIR)/*
1904         for i in $(ALL_APIDOC_HS_DIRS); do \
1905           @mkdir_p@ $$i; \
1906           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1907         done
1908         set -e ; \
1909         export LC_ALL=en_US.UTF-8; \
1910         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1911         if [ "$(HS_PARALLEL3)" ]; \
1912         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1913         fi; \
1914         if [ "$(HS_REGEX_PCRE)" ]; \
1915         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1916         fi; \
1917         for file in $(HS_LIBTESTBUILT_SRCS); do \
1918           f_nosrc=$${file##src/}; \
1919           f_notst=$${f_nosrc##test/hs/}; \
1920           f_html=$${f_notst%%.hs}.html; \
1921           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
1922         done ; \
1923         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1924           -t ganeti -p src/haddock-prologue \
1925           --source-module="%{MODULE/.//}.html" \
1926           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1927           $$OPTGHC \
1928           $(HS_LIBTESTBUILT_SRCS)
1929
1930 .PHONY: TAGS
1931 TAGS: $(GENERATED_FILES)
1932         rm -f TAGS
1933         $(GHC) -e ":etags" -v0 \
1934           $(filter-out -O -Werror,$(HFLAGS)) \
1935           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1936           $(HS_LIBTEST_SRCS)
1937         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1938           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1939           -path './qa/*.py' | \
1940           etags -l python -a -
1941
1942 .PHONY: coverage
1943 if WANT_HTOOLS
1944 coverage: py-coverage hs-coverage
1945 else
1946 coverage: py-coverage
1947 endif
1948
1949 .PHONY: py-coverage
1950 py-coverage: $(GENERATED_FILES) $(python_tests)
1951         @test -n "$(PYCOVERAGE)" || \
1952             { echo 'python-coverage' not found during configure; exit 1; }
1953         set -e; \
1954         COVERAGE=$(PYCOVERAGE) \
1955         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1956         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1957         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1958         $(PLAIN_TESTS_ENVIRONMENT) \
1959         $(abs_top_srcdir)/autotools/gen-py-coverage \
1960         $(python_tests)
1961
1962 .PHONY: hs-coverage
1963 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1964         rm -f *.tix
1965         $(MAKE) $(AM_MAKEFLAGS) hs-check
1966         @mkdir_p@ $(COVERAGE_HS_DIR)
1967         hpc sum --union $(HPCEXCL) \
1968           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1969         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1970         hpc report coverage-hs.tix
1971         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1972
1973 # Special "kind-of-QA" target for htools, needs special setup (all
1974 # tools compiled with -fhpc)
1975 .PHONY: live-test
1976 live-test: all
1977         set -e ; \
1978         cd src; \
1979         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1980         rm -f *.tix *.mix; \
1981         ./live-test.sh; \
1982         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1983           --output=live-test.tix ; \
1984         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1985         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1986           --srcdir=.. $(HPCEXCL) ; \
1987         hpc report --srcdir=.. live-test $(HPCEXCL)
1988
1989 commit-check: distcheck lint apidoc
1990
1991 .PHONY: gitignore-check
1992 gitignore-check:
1993         @if [ -n "`git status --short`" ]; then \
1994           echo "Git status is not clean!" 1>&2 ; \
1995           git status --short; \
1996           exit 1; \
1997         fi
1998
1999 # target to rebuild all man pages (both groff and html output)
2000 .PHONY: man
2001 man: $(man_MANS) $(manhtml)
2002
2003 # Target that builds all binaries (including those that are not
2004 # rebuilt except when running the tests)
2005 .PHONY: really-all
2006 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2007
2008 # we don't need the ancient implicit rules:
2009 %: %,v
2010 %: RCS/%,v
2011 %: RCS/%
2012 %: s.%
2013 %: SCCS/s.%
2014
2015 -include ./Makefile.local
2016
2017 # vim: set noet :